#include <stdio.h>
#include <stdlib.h>

#if !defined(INIT_VALUE)
#error("Please compile with the option -DINIT_VALUE=n");
#endif

int somma(int x) {
    static int s = INIT_VALUE;
    s +=x;
    return s;
}

int somma_r(int x, int *s) {
    *s += x;
    return *s;
}

int main() {
    int s = INIT_VALUE;
	
    for(;;) {
	int val;

	fprintf(stdout, "Inserisci un numero (<0 per terminare): ");
	if (fscanf(stdin, "%d", &val) != 1) {
	    perror("fscanf");
	    return EXIT_FAILURE;
	}
	
	if (val == -1) break;

	fprintf(stdout, "somma %d\n", somma(val));
	fprintf(stdout, "somma %d\n", somma_r(val, &s));
    }
    return 0;       
}
